(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./MultilineTextDrawer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadMultilineTextShape = void 0;
    const MultilineTextDrawer_1 = require("./MultilineTextDrawer");
    async function loadMultilineTextShape(engine, refresh = true) {
        await engine.addShape("multiline-text", new MultilineTextDrawer_1.MultilineTextDrawer(), refresh);
    }
    exports.loadMultilineTextShape = loadMultilineTextShape;
});
